package main

athena_db[r] {
  r := input.resource_changes[_]
  r.type == "aws_athena_database"
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# Restrict unencrypted athena results
athena_results_unencrypted[reason] {
    r := athena_db[_]
    count(r.change.after.encryption_configuration) = 0
    reason := sprintf(
      "%s: Athena results with no encryption enabled. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
      [r.name]
    )
}

deny_athena_results_unencrypted[msg]{
  not array_contains(warning_mode, "athena_results_unencrypted")
  athena_results_unencrypted[_] != []
  msg := athena_results_unencrypted[_]
}

warn_athena_results_unencrypted[msg]{
  array_contains(warning_mode, "athena_results_unencrypted")
  athena_results_unencrypted[_] != []
  msg := athena_results_unencrypted[_]
}