package main

# Test DynamoDB check for AWS owned CMK using AWS owned CMK
test_server_side_encryption_aws_owned_cmk {
    i := data.mock.dynamo_aws_owned_cmk
    r1 := warn_db_server_side_encryption_aws_owned_cmk with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_db_server_side_encryption_aws_owned_cmk with input as i with data.config.warn_mode as ["db_server_side_encryption_aws_owned_cmk"]
    count(r2) == 1
    r3 := deny_db_server_side_encryption_aws_owned_cmk with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_db_server_side_encryption_aws_owned_cmk with input as i with data.config.warn_mode as ["db_server_side_encryption_aws_owned_cmk"]
    count(r4) == 0
    count(r1) + count(r3) == 1 # Warning mode is off
    count(r2) + count(r4) == 1 # Warning mode is on
}

# Test DynamoDB check for Point in Time Recovery
test_db_point_in_time_recovery_disabled {
    i := data.mock.dynamo_backups_disabled
    r1 := warn_db_point_in_time_recovery with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_db_point_in_time_recovery with input as i with data.config.warn_mode as ["db_point_in_time_recovery"]
    count(r2) == 1
    r3 := deny_db_point_in_time_recovery with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_db_point_in_time_recovery with input as i with data.config.warn_mode as ["db_point_in_time_recovery"]
    count(r4) == 0
    count(r1) + count(r3) == 1 # Warning mode is off
    count(r2) + count(r4) == 1 # Warning mode is on
}

test_db_point_in_time_recovery_enabled {
    i := data.mock.dynamo_backups_enabled
    r1 := warn_db_point_in_time_recovery with input as i with data.config.warn_mode as []
    r2 := warn_db_point_in_time_recovery with input as i with data.config.warn_mode as ["db_point_in_time_recovery"]
    r3 := deny_db_point_in_time_recovery with input as i with data.config.warn_mode as []
    r4 := deny_db_point_in_time_recovery with input as i with data.config.warn_mode as ["db_point_in_time_recovery"]
    count(r1) + count(r3) + count(r2) + count(r4) == 0
}