package main

# filter ebs resources
ebs_resources[i] = r {
    r := input.resource_changes[i]
    r.type == "aws_ebs_volume"
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# === Unencrypted EBS volumes ===
ebs_unencrypted[reason] {
    r := ebs_resources[_]
    ebs_changeset = r.change.after
    not object.get(ebs_changeset, "encrypted", false) == true
    reason := sprintf(
      "%s: EBS encryption is required. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
        [r.address]
    )
}

deny_ebs_unencrypted[msg]{
  not array_contains(warning_mode, "ebs_unencrypted")
  ebs_unencrypted[_] != []
  msg := ebs_unencrypted[_]
}

warn_ebs_unencrypted[msg]{
  array_contains(warning_mode, "ebs_unencrypted")
  ebs_unencrypted[_] != []
  msg := ebs_unencrypted[_]
}