package main

# filter EC2 instnaces
ec2_instances[i] = r {
    r := input.resource_changes[i]
    r.type == "aws_instance"
}


# Helper: get all unencrypted ECS EBS
ec2_ebs_encrypted(resource) {
    ch := resource.change.after
    rbd := object.filter(ch, ["root_block_device"])
    object.get(rbd.root_block_device[_], "encrypted", false)
}

# Helper: module address of the resource
module_address[i] = address {
	changeset := input.resource_changes[i]
	address := changeset.address
}

# Helper: map all unencrypted EC2s
map_unencrypted_ec2_ebs_volumes[i] = resources {
    changeset := ec2_instances[i]
    resources := [resource | resource := module_address[i]; not ec2_ebs_encrypted(changeset)]
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# === Check EC2 is encrypted  ===
unencrypted_ec2_ebs_volumes[reason] {
    resources := map_unencrypted_ec2_ebs_volumes[_][_]
    resources != []
    reason := sprintf("Resources %v do not have encrypted EBS volume(s). See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.", [resources])
}

deny_unencrypted_ec2_ebs_volumes[msg]{
  not array_contains(warning_mode, "unencrypted_ec2_ebs_volumes")
  unencrypted_ec2_ebs_volumes[_] != []
  msg := unencrypted_ec2_ebs_volumes[_]
}

warn_unencrypted_ec2_ebs_volumes[msg]{
  array_contains(warning_mode, "unencrypted_ec2_ebs_volumes")
  unencrypted_ec2_ebs_volumes[_] != []
  msg := unencrypted_ec2_ebs_volumes[_]
}