package main

test_ec2_ebs_encrypted {
  encrypted_root_ebs_volume_resource := data.mock.valid_ec2_root_volume_encryption.resource_changes[0]
  not_encrypted_root_ebs_volume_resource := data.mock.invalid_ec2_root_volume_encryption.resource_changes[1]
  not_encrypted_key_not_defined_root_ebs_volume_resource := data.mock.invalid_ec2_root_volume_encryption.resource_changes[0]
  not_encrypted_object_not_defined_root_ebs_volume_resource := data.mock.invalid_ec2_root_volume_encryption.resource_changes[5]
  ec2_ebs_encrypted(encrypted_root_ebs_volume_resource)
  not ec2_ebs_encrypted(not_encrypted_root_ebs_volume_resource)
  not ec2_ebs_encrypted(not_encrypted_key_not_defined_root_ebs_volume_resource)
  not ec2_ebs_encrypted(not_encrypted_object_not_defined_root_ebs_volume_resource)
}

test_valid_ec2_dataset {
    i := data.mock.valid_ec2_root_volume_encryption
    ec2_ebs_encrypted_result = map_unencrypted_ec2_ebs_volumes with input as i
    total_result = count([address| address := ec2_ebs_encrypted_result[_][_]])
    total_result == 0
}

test_invalid_ec2_dataset {
    i := data.mock.invalid_ec2_root_volume_encryption
    ec2_ebs_encrypted_result = map_unencrypted_ec2_ebs_volumes with input as i
    total_result = count([address| address := ec2_ebs_encrypted_result[_][_]])
    total_result == 3
}

test_unencrypted_ec2_ebs_volumes {
    i := data.mock.invalid_ec2_root_volume_encryption
    r1 := warn_unencrypted_ec2_ebs_volumes with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_unencrypted_ec2_ebs_volumes with input as i with data.config.warn_mode as ["unencrypted_ec2_ebs_volumes"]
    count(r2) == 3
    r3 := deny_unencrypted_ec2_ebs_volumes with input as i with data.config.warn_mode as []
    count(r3) == 3
    r4 := deny_unencrypted_ec2_ebs_volumes with input as i with data.config.warn_mode as ["unencrypted_ec2_ebs_volumes"]
    count(r4) == 0
    count(r1) + count(r3) == 3 # Warning mode is off
    count(r2) + count(r4) == 3 # Warning mode is on
}