package main

allowed_ssl_policy = ["ELBSecurityPolicy-TLS-1-2-Ext-2018-06", "ELBSecurityPolicy-FS-1-2-Res-2019-08"]

allowed_ssl_policy_elb = "ELBSecurityPolicy-TLS-1-2-2017-01"

aws_lb_listener[a] {
	a := input.resource_changes[_]
	a.type == "aws_lb_listener"
}

aws_elb_listener[e] {
	e := input.resource_changes[_]
	e.type == "aws_load_balancer_policy"
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# === Rule to restrict SSL Security Policy on ALB / NLB ===
alb_ssl_policy[reason] {
	a := aws_lb_listener[_]
	not array_contains(allowed_ssl_policy, a.change.after.ssl_policy)
	reason := sprintf("%s: For ALB/NLB SSL-POLICY %q is not allowed See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.", [a.address, a.change.after.ssl_policy])
}

deny_alb_ssl_policy[msg]{
  not array_contains(warning_mode, "alb_ssl_policy")
  alb_ssl_policy[_] != []
  msg := alb_ssl_policy[_]
}

warn_alb_ssl_policy[msg]{
  array_contains(warning_mode, "alb_ssl_policy")
  alb_ssl_policy[_] != []
  msg := alb_ssl_policy[_]
}

# === Rule to restrict SSL Security Policy on ELB ===
elb_ssl_policy[reason] {
	e := aws_elb_listener[_]
	e.change.after.policy_attribute[_].value != allowed_ssl_policy_elb
	reason := sprintf("%s: For ELB(Classic loadbalancer) SSL-POLICY %q is not allowed See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.", [e.address, e.change.after.policy_attribute[_].value])
}

deny_elb_ssl_policy[msg]{
  not array_contains(warning_mode, "elb_ssl_policy")
  elb_ssl_policy[_] != []
  msg := elb_ssl_policy[_]
}

warn_elb_ssl_policy[msg]{
  array_contains(warning_mode, "elb_ssl_policy")
  elb_ssl_policy[_] != []
  msg := elb_ssl_policy[_]
}
