package main

aws_lb_resources[r] {
	r := input.resource_changes[_]
	r.type == "aws_lb"
}

alb_access_logs[reason] {
    r := aws_lb_resources[_]
    logs := object.get(r.change.after.access_logs[0],"enabled",false)
    logs == false
    reason := sprintf(
        "%s : Access logs must be enabled on all loadbalancers. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
        [r.address]
    )
}

deny_alb_access_logs[msg]{
  not array_contains(warning_mode, "alb_access_logs")
  alb_access_logs[_] != []
  msg := alb_access_logs[_]
}

warn_alb_access_logs[msg]{
  array_contains(warning_mode, "alb_access_logs")
  alb_access_logs[_] != []
  msg := alb_access_logs[_]
}