package main

aws_lb_resources[r] {
	r := input.resource_changes[_]
	r.type == "aws_lb"
}

alb_invalid_headers[reason] {
    r := aws_lb_resources[_]
    header = r.change.after
    not object.get(header, "drop_invalid_header_fields", false) == true
    reason := sprintf(
        "%s : Dropping invalid header fields must be turned on on all loadbalancers. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
        [r.address]
    )
}

deny_alb_invalid_headers[msg]{
  not array_contains(warning_mode, "alb_invalid_headers")
  alb_invalid_headers[_] != []
  msg := alb_invalid_headers[_]
}

warn_alb_invalid_headers[msg]{
  array_contains(warning_mode, "alb_invalid_headers")
  alb_invalid_headers[_] != []
  msg := alb_invalid_headers[_]
}