package main

## Test for valid alb policy
test_alb_ssl_policy_valid {
    i := data.mock.valid_alb_policy
    r1 := warn_alb_ssl_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_alb_ssl_policy with input as i with data.config.warn_mode as ["alb_ssl_policy"]
    count(r2) == 0
    r3 := deny_alb_ssl_policy with input as i with data.config.warn_mode as []
    count(r3) == 0
    r4 := deny_alb_ssl_policy with input as i with data.config.warn_mode as ["alb_ssl_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 0 # Warning mode is off
    count(r3) + count(r4) == 0 # Warning mode is on
}

## Test for invalid alb policy
test_alb_ssl_policy_invalid {
    i := data.mock.invalid_alb_policy
    r1 := warn_alb_ssl_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_alb_ssl_policy with input as i with data.config.warn_mode as ["alb_ssl_policy"]
    count(r2) == 2
    r3 := deny_alb_ssl_policy with input as i with data.config.warn_mode as []
    count(r3) == 2
    r4 := deny_alb_ssl_policy with input as i with data.config.warn_mode as ["alb_ssl_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 2 # Warning mode is off
    count(r3) + count(r4) == 2 # Warning mode is on
}

## Test for valid elb policy
test_elb_ssl_policy_valid {
    i := data.mock.valid_elb_policy
    r1 := warn_elb_ssl_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_elb_ssl_policy with input as i with data.config.warn_mode as ["elb_ssl_policy"]
    count(r2) == 0
    r3 := deny_elb_ssl_policy with input as i with data.config.warn_mode as []
    count(r3) == 0
    r4 := deny_elb_ssl_policy with input as i with data.config.warn_mode as ["elb_ssl_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 0 # Warning mode is off
    count(r3) + count(r4) == 0 # Warning mode is on
}

## Test for invalid elb policy
test_elb_ssl_policy_invalid {
    i := data.mock.invalid_elb_policy
    r1 := warn_elb_ssl_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_elb_ssl_policy with input as i with data.config.warn_mode as ["elb_ssl_policy"]
    count(r2) == 1
    r3 := deny_elb_ssl_policy with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_elb_ssl_policy with input as i with data.config.warn_mode as ["elb_ssl_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}