package kubernetes

# Containers for Jobs/Pods/Deployments should should have the imagePullPolicy set to Always
# Deployments & Jobs Version
resource_container_image_pull_policy[reason] {
    r := get_containers[_]
    containers := r.spec.template.spec.containers[_]
    not containers.imagePullPolicy == "Always"
    reason := sprintf("%s %s: Container %s imagePullPolicy should be set to 'Always'.", [r.kind, r.metadata.name, containers.name])
}

# Pod Version
resource_container_image_pull_policy[reason] {
    r := get_containers[_]
    containers := r.spec.containers[_]
    not containers.imagePullPolicy == "Always"
    reason := sprintf("%s %s: Container %s imagePullPolicy should be set to 'Always'.", [r.kind, r.metadata.name, containers.name])
}

# Actual Test Cases
deny_resource_container_image_pull_policy[msg]{
  not array_contains(warning_mode, "resource_container_image_pull_policy")
  resource_container_image_pull_policy[_] != []
  msg := resource_container_image_pull_policy[_]
}

warn_resource_container_image_pull_policy[msg]{
  array_contains(warning_mode, "resource_container_image_pull_policy")
  resource_container_image_pull_policy[_] != []
  msg := resource_container_image_pull_policy[_]
}