package kubernetes

# Test for invalid Kubernetes imagePullPolicy
test_deployment_image_pull_policy_invalid {
    i := data.mock.bad_deployment
    r1 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r2) == 1
    r3 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_deployment_image_pull_policy_invalid {
    i := data.mock.bad_job
    r1 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r2) == 1
    r3 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes imagePullPolicy
test_deployment_image_pull_policy_valid {
    i := data.mock.good_job
    r1 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    r3 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

test_deployment_image_pull_policy_valid {
    i := data.mock.good_deployment
    r1 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    r3 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes liveness probes
test_pod_image_pull_policy_invalid {
    i := data.mock.bad_pod
    r1 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r2) == 1
    r3 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes liveness probes
test_pod_image_pull_policy_valid {
    i := data.mock.good_pod
    r1 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    r3 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_image_pull_policy with input as i with data.config.warn_mode as ["resource_container_image_pull_policy"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}