package kubernetes

# Test for invalid Kubernetes containers[_].resources.requests configured for CPU & Memory
test_resource_container_using_latest_invalid {
    i := data.mock.bad_job
    r1 := warn_resource_container_using_latest with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_using_latest with input as i with data.config.warn_mode as ["resource_container_using_latest"]
    count(r2) == 1
    r3 := deny_resource_container_using_latest with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_using_latest with input as i with data.config.warn_mode as ["resource_container_using_latest"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes containers[_].resources.requests configured for CPU & Memory
test_resource_container_using_latest_valid {
    i := data.mock.good_job
    r1 := warn_resource_container_using_latest with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_using_latest with input as i with data.config.warn_mode as ["resource_container_using_latest"]
    r3 := deny_resource_container_using_latest with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_using_latest with input as i with data.config.warn_mode as ["resource_container_using_latest"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}