package kubernetes

# Test for Jobs/Pods/Deployments should have containers[_].securityContext.readOnlyRootFilesystem set to True
test_resource_container_readonlyrootfilesystem_invalid {
    i := data.mock.bad_job
    r1 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    count(r2) == 1
    r3 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_resource_container_readonlyrootfilesystem_invalid {
    i := data.mock.bad_pod
    r1 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    count(r2) == 1
    r3 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for Jobs/Pods/Deployments should have containers[_].securityContext.readOnlyRootFilesystem set to True
test_resource_container_readonlyrootfilesystem_valid {
    i := data.mock.good_job
    r1 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    r3 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

test_resource_container_readonlyrootfilesystem_valid {
    i := data.mock.good_pod
    r1 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    r3 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_readonlyrootfilesystem with input as i with data.config.warn_mode as ["resource_container_readonlyrootfilesystem"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}