package kubernetes

# Test for invalid Kubernetes containers[_].securityContext.runAsUser for jobs
test_resource_container_run_as_user_job {
    i := data.mock.bad_job
    r1 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    count(r2) == 1
    r3 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for invalid Kubernetes containers[_].securityContext.runAsUser for pods
test_resource_container_run_as_user_pod {
    i := data.mock.bad_pod
    r1 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    count(r2) == 1
    r3 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes containers[_].securityContext.runAsUser for jobs
test_resource_container_run_as_user_job {
    i := data.mock.good_job
    r1 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    r3 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for valid Kubernetes containers[_].securityContext.runAsUser for pods
test_resource_container_run_as_user_pod {
    i := data.mock.good_pod
    r1 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    r3 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_run_as_user with input as i with data.config.warn_mode as ["resource_container_run_as_user"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes containers[_].securityContext.runAsGroup for jobs
test_resource_container_run_as_group_job {
    i := data.mock.bad_job
    r1 := warn_resource_container_run_as_group with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_run_as_group with input as i with data.config.warn_mode as ["resource_container_run_as_group"]
    count(r2) == 1
    r3 := deny_resource_container_run_as_group with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_run_as_group with input as i with data.config.warn_mode as ["resource_container_run_as_group"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for invalid Kubernetes containers[_].securityContext.runAsGroup for pods
test_resource_container_run_as_group_pod {
    i := data.mock.bad_pod
    r1 := warn_resource_container_run_as_group with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_run_as_group with input as i with data.config.warn_mode as ["resource_container_run_as_group"]
    count(r2) == 1
    r3 := deny_resource_container_run_as_group with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_run_as_group with input as i with data.config.warn_mode as ["resource_container_run_as_group"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}