package kubernetes

# Test for invalid job security context
test_resource_container_security_context_privileged_invalid {
    i := data.mock.bad_job
    r1 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r2) == 1
    r3 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_resource_container_security_context_privileged_invalid {
    i := data.mock.bad_pod
    r1 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r2) == 1
    r3 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_resource_container_security_context_privileged_invalid {
    i := data.mock.bad_deployment
    r1 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r2) == 2
    r3 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    count(r3) == 2
    r4 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r4) == 0
    count(r1) + count(r2) == 2 # Warning mode is off
    count(r3) + count(r4) == 2 # Warning mode is on
}

# Test for valid job security context
test_job_security_context_privileged_valid {
    i := data.mock.good_job
    r1 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    r3 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

test_job_security_context_privileged_valid {
    i := data.mock.good_pod
    r1 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    r3 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

test_job_security_context_privileged_valid {
    i := data.mock.good_deployment
    r1 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    r2 := warn_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    r3 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as []
    r4 := deny_resource_container_security_context_privileged with input as i with data.config.warn_mode as ["resource_container_security_context_privileged"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}