package kubernetes

cronjobs[r]{
    r := input
    input.kind = "CronJob"
}

# Cronjobs should have a configured deadline
cronjob_missing_deadline[reason] {
    r := cronjobs[_]
    not r.spec.startingDeadlineSeconds
    reason := sprintf("%s %s: Cronjob is missing a configured deadline. Set spec.startingDeadlineSeconds", [r.kind, r.metadata.name])
}

# Actual Test Cases
deny_cronjob_missing_deadline[msg]{
    not array_contains(warning_mode, "cronjob_missing_deadline")
    findings := cronjob_missing_deadline
    findings[_] != []
    msg := findings[_]
}

warn_cronjob_missing_deadline[msg]{
    array_contains(warning_mode, "cronjob_missing_deadline")
    findings := cronjob_missing_deadline
    findings[_] != []
    msg := findings[_]
}