package kubernetes

# Test for invalid cronjob deadline
test_cronjob_missing_deadline_invalid {
    i := data.mock.bad_cronjob
    r1 := warn_cronjob_missing_deadline with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_cronjob_missing_deadline with input as i with data.config.warn_mode as ["cronjob_missing_deadline"]
    count(r2) == 1
    r3 := deny_cronjob_missing_deadline with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_cronjob_missing_deadline with input as i with data.config.warn_mode as ["cronjob_missing_deadline"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid cronjob deadline
test_cronjob_missing_deadline_valid {
    i := data.mock.good_cronjob
    r1 := warn_cronjob_missing_deadline with input as i with data.config.warn_mode as []
    r2 := warn_cronjob_missing_deadline with input as i with data.config.warn_mode as ["cronjob_missing_deadline"]
    r3 := deny_cronjob_missing_deadline with input as i with data.config.warn_mode as []
    r4 := deny_cronjob_missing_deadline with input as i with data.config.warn_mode as ["cronjob_missing_deadline"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}
