package kubernetes

#  Test for flagged API version with UNSUPPORTED Kind
test_resource_deprecated_api_kind_unsupported {
    i := data.mock.deprecated_api_kind_unsupported
    r1 := warn_resource_deprecated_api with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_deprecated_api with input as i with data.config.warn_mode as ["resource_deprecated_api"]
    count(r2) == 1
    r3 := deny_resource_deprecated_api with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_deprecated_api with input as i with data.config.warn_mode as ["resource_deprecated_api"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for flagged API version with SUPPORTED Kind
test_resource_deprecated_api_kind_supported {
    i := data.mock.deprecated_api_kind_supported
    r1 := warn_resource_deprecated_api with input as i with data.config.warn_mode as []
    r2 := warn_resource_deprecated_api with input as i with data.config.warn_mode as ["resource_deprecated_api"]
    r3 := deny_resource_deprecated_api with input as i with data.config.warn_mode as []
    r4 := deny_resource_deprecated_api with input as i with data.config.warn_mode as ["resource_deprecated_api"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for unflagged, fully supported API version
test_resource_deprecated_api_supported {
    i := data.mock.deprecated_api_supported
    r1 := warn_resource_deprecated_api with input as i with data.config.warn_mode as []
    r2 := warn_resource_deprecated_api with input as i with data.config.warn_mode as ["resource_deprecated_api"]
    r3 := deny_resource_deprecated_api with input as i with data.config.warn_mode as []
    r4 := deny_resource_deprecated_api with input as i with data.config.warn_mode as ["resource_deprecated_api"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}