package kubernetes

hpa[r] {
    r := input
    input.kind == "HorizontalPodAutoscaler"
}

# HPA should have a minimum of three replicas set
hpa_min_proxy_count[reason] {
    r := hpa[_]
    r.spec.minReplicas < 3
    reason := sprintf("%s %s: HPA should have a minimum of three replicas set", [r.kind, r.metadata.name])
}

# Actual Test Cases
deny_hpa_min_proxy_count[msg]{
  not array_contains(warning_mode, "hpa_min_proxy_count")
  hpa_min_proxy_count[_] != []
  msg := hpa_min_proxy_count[_]
}

warn_hpa_min_proxy_count[msg]{
  array_contains(warning_mode, "hpa_min_proxy_count")
  hpa_min_proxy_count[_] != []
  msg := hpa_min_proxy_count[_]
}