package kubernetes

# Test for invalid Kubernetes readiness probes
test_hpa_min_proxy_count_invalid {
    i := data.mock.bad_hpa
    r1 := warn_hpa_min_proxy_count with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_hpa_min_proxy_count with input as i with data.config.warn_mode as ["hpa_min_proxy_count"]
    count(r2) == 1
    r3 := deny_hpa_min_proxy_count with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_hpa_min_proxy_count with input as i with data.config.warn_mode as ["hpa_min_proxy_count"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes readiness probes
test_hpa_min_proxy_count_valid {
    i := data.mock.good_hpa
    r1 := warn_hpa_min_proxy_count with input as i with data.config.warn_mode as []
    r2 := warn_hpa_min_proxy_count with input as i with data.config.warn_mode as ["hpa_min_proxy_count"]
    r3 := deny_hpa_min_proxy_count with input as i with data.config.warn_mode as []
    r4 := deny_hpa_min_proxy_count with input as i with data.config.warn_mode as ["hpa_min_proxy_count"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}