package kubernetes
import data.config

default warning_mode = []
warning_mode = config.warn_mode { config.warn_mode }

name = input.metadata.name

# Array contains helper function
array_contains(arr, elem) {
  arr[_] = elem
}

# Get input.kinds with containers
get_containers[r] {
    r := input
    input.kind == "Deployment"
}

get_containers[r] {
    r := input
    input.kind == "Job"
}

get_containers[r] {
    r := input
    input.kind == "Pod"
}

# The following are exceptions for the infra-chart Terraform jobs, approved by PSEC to have writeable filesystems
# Used for resource_container_readonlyrootfilesystem
infra_chart_exceptions(name) {
    not regex.match(`.*-deploy-tf$`, name) # Exception
    not regex.match(`.*-removal$`, name) # Exception
    not regex.match(`.*-debug$`, name) # Exception
    not regex.match(`.*-deploy-primary$`, name) # Exception
    not regex.match(`.*-deploy-user$`, name) # Exception
    not regex.match(`.*-cleanup$`, name) # Exception
}