package kubernetes

pdbs[r] {
    r := input
    input.kind == "PodDisruptionBudget"
}

# maxUnavailable should not be set to 0 or 0%
misconfigured_pdb[reason] {
    r := pdbs[_]
    r.spec.maxUnavailable == 0
    reason := sprintf("%s: PodDisruptionBudget is misconfigured. spec.maxUnavailable should be set to a value greater than 0, currently is set to %v", [r.metadata.name, r.spec.maxUnavailable])
}

misconfigured_pdb[reason] {
    r := pdbs[_]
    r.spec.maxUnavailable == "0%"
    reason := sprintf("%s: PodDisruptionBudget is misconfigured. spec.maxUnavailable should be set to a value greater than 0%%, currently is set to %v", [r.metadata.name, r.spec.maxUnavailable])
}

deny_misconfigured_pdb[msg]{
  not array_contains(warning_mode, "misconfigured_pdb")
  misconfigured_pdb[_] != []
  msg := misconfigured_pdb[_]
}

warn_misconfigured_pdb[msg]{
  array_contains(warning_mode, "misconfigured_pdb")
  misconfigured_pdb[_] != []
  msg := misconfigured_pdb[_]
}