package kubernetes

# Test for invalid Kubernetes readiness probes
test_pod_missing_readiness_probe_invalid {
    i := data.mock.bad_pod
    r1 := warn_pod_missing_readiness_probe with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_pod_missing_readiness_probe with input as i with data.config.warn_mode as ["pod_missing_readiness_probe"]
    count(r2) == 1
    r3 := deny_pod_missing_readiness_probe with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_pod_missing_readiness_probe with input as i with data.config.warn_mode as ["pod_missing_readiness_probe"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes readiness probes
test_pod_missing_readiness_probe_valid {
    i := data.mock.good_pod
    r1 := warn_pod_missing_readiness_probe with input as i with data.config.warn_mode as []
    r2 := warn_pod_missing_readiness_probe with input as i with data.config.warn_mode as ["pod_missing_readiness_probe"]
    r3 := deny_pod_missing_readiness_probe with input as i with data.config.warn_mode as []
    r4 := deny_pod_missing_readiness_probe with input as i with data.config.warn_mode as ["pod_missing_readiness_probe"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes liveness probes
test_pod_missing_liveness_probe_invalid {
    i := data.mock.bad_pod
    r1 := warn_pod_missing_liveness_probe with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_pod_missing_liveness_probe with input as i with data.config.warn_mode as ["pod_missing_liveness_probe"]
    count(r2) == 1
    r3 := deny_pod_missing_liveness_probe with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_pod_missing_liveness_probe with input as i with data.config.warn_mode as ["pod_missing_liveness_probe"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes liveness probes
test_pod_missing_liveness_probe_valid {
    i := data.mock.good_pod
    r1 := warn_pod_missing_liveness_probe with input as i with data.config.warn_mode as []
    r2 := warn_pod_missing_liveness_probe with input as i with data.config.warn_mode as ["pod_missing_liveness_probe"]
    r3 := deny_pod_missing_liveness_probe with input as i with data.config.warn_mode as []
    r4 := deny_pod_missing_liveness_probe with input as i with data.config.warn_mode as ["pod_missing_liveness_probe"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}