package kubernetes

# Test for invalid Kubernetes recommended deployment labels
test_resource_missing_tags_invalid {
    i := data.mock.deployment_invalid_labels
    r1 := warn_resource_missing_tags with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_missing_tags with input as i with data.config.warn_mode as ["resource_missing_tags"]
    count(r2) == 1
    r3 := deny_resource_missing_tags with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_missing_tags with input as i with data.config.warn_mode as ["resource_missing_tags"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes recommended deployment labels
test_resource_missing_tags_valid {
    i := data.mock.deployment_valid_labels
    r1 := warn_resource_missing_tags with input as i with data.config.warn_mode as []
    r2 := warn_resource_missing_tags with input as i with data.config.warn_mode as ["resource_missing_tags"]
    r3 := deny_resource_missing_tags with input as i with data.config.warn_mode as []
    r4 := deny_resource_missing_tags with input as i with data.config.warn_mode as ["resource_missing_tags"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes recommended deployment annotations
test_resource_missing_annotations_invalid {
    i := data.mock.deployment_invalid_labels
    r1 := warn_resource_missing_annotations with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_resource_missing_annotations with input as i with data.config.warn_mode as ["resource_missing_annotations"]
    count(r2) == 1
    r3 := deny_resource_missing_annotations with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_resource_missing_annotations with input as i with data.config.warn_mode as ["resource_missing_annotations"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes recommended deployment labels
test_resource_missing_annotations_valid {
    i := data.mock.deployment_valid_annotations
    r1 := warn_resource_missing_annotations with input as i with data.config.warn_mode as []
    r2 := warn_resource_missing_annotations with input as i with data.config.warn_mode as ["resource_missing_annotations"]
    r3 := deny_resource_missing_annotations with input as i with data.config.warn_mode as []
    r4 := deny_resource_missing_annotations with input as i with data.config.warn_mode as ["resource_missing_annotations"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for invalid Kubernetes recommended deployment annotations
test_deployment_owner_annotation_invalid {
    i := data.mock.deployment_invalid_labels
    r1 := warn_deployment_bad_owner_annotation with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_deployment_bad_owner_annotation with input as i with data.config.warn_mode as ["deployment_bad_owner_annotation"]
    count(r2) == 1
    r3 := deny_deployment_bad_owner_annotation with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_deployment_bad_owner_annotation with input as i with data.config.warn_mode as ["deployment_bad_owner_annotation"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes recommended deployment labels
test_deployment_owner_annotation_valid {
    i := data.mock.deployment_valid_annotations
    r1 := warn_deployment_bad_owner_annotation with input as i with data.config.warn_mode as []
    r2 := warn_deployment_bad_owner_annotation with input as i with data.config.warn_mode as ["deployment_bad_owner_annotation"]
    r3 := deny_deployment_bad_owner_annotation with input as i with data.config.warn_mode as []
    r4 := deny_deployment_bad_owner_annotation with input as i with data.config.warn_mode as ["deployment_bad_owner_annotation"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}
# Test for invalid Kubernetes recommended deployment annotations
test_deployment_sguid_annotation_invalid {
    i := data.mock.deployment_invalid_labels
    r1 := warn_deployment_sguid_annotation with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_deployment_sguid_annotation with input as i with data.config.warn_mode as ["resource_bad_sguid_annotation"]
    count(r2) == 1
    r3 := deny_deployment_sguid_annotation with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_deployment_sguid_annotation with input as i with data.config.warn_mode as ["resource_bad_sguid_annotation"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for valid Kubernetes recommended deployment labels
test_deployment_sguid_annotation_valid {
    i := data.mock.deployment_valid_annotations
    r1 := warn_deployment_sguid_annotation with input as i with data.config.warn_mode as []
    r2 := warn_deployment_sguid_annotation with input as i with data.config.warn_mode as ["resource_bad_sguid_annotation"]
    r3 := deny_deployment_sguid_annotation with input as i with data.config.warn_mode as []
    r4 := deny_deployment_sguid_annotation with input as i with data.config.warn_mode as ["resource_bad_sguid_annotation"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}
