package main

kinesis[r] {
  r := input.resource_changes[_]
  r.type == "aws_kinesis_stream"
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# Rule to restrict unencrypted kinesis streams
kinesis_unencrypted[reason] {
    r := kinesis[_]
    # encryption_type is the exact case as it's written in teraform, ie kMS, KmS, KMS, etc
    not upper(r.change.after.encryption_type) == "KMS"
    reason := sprintf(
      "%s: Kinesis stream doesn't have encryption enabled. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
      [r.name]
    )
}

deny_kinesis_unencrypted[msg]{
  not array_contains(warning_mode, "kinesis_unencrypted")
  kinesis_unencrypted[_] != []
  msg := kinesis_unencrypted[_]
}

warn_kinesis_unencrypted[msg]{
  array_contains(warning_mode, "kinesis_unencrypted")
  kinesis_unencrypted[_] != []
  msg := kinesis_unencrypted[_]
}