package main

kms_keys[r] {
    r := input.resource_changes[_]
    r.type == "aws_kms_key"
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# Rule to require key rotation on KMS keys
kms_key_rotation[reason] {
    r := kms_keys[_]
    r.change.after.enable_key_rotation == false
    reason := sprintf(
        "%s: Key rotation is required, enable_key_rotation is %q. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
        [r.address, r.change.after.enable_key_rotation]
    )
}

deny_kms_key_rotation[msg]{
  not array_contains(warning_mode, "kms_key_rotation")
  kms_key_rotation[_] != []
  msg := kms_key_rotation[_]
}

warn_kms_key_rotation[msg]{
  array_contains(warning_mode, "kms_key_rotation")
  kms_key_rotation[_] != []
  msg := kms_key_rotation[_]
}