package main

# Test KMS check that key rotation is enabled on valid plan
test_kms_key_rotation_valid {
    i := data.mock.kms_key_rotation_enabled
    r1 := warn_kms_key_rotation with input as i with data.config.warn_mode as []
    r2 := warn_kms_key_rotation with input as i with data.config.warn_mode as ["kms_key_rotation"]
    r3 := deny_kms_key_rotation with input as i with data.config.warn_mode as []
    r4 := deny_kms_key_rotation with input as i with data.config.warn_mode as ["kms_key_rotation"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test KMS check that key rotation is enabled on invalid plan
test_kms_key_rotation_invalid {
    i := data.mock.kms_key_rotation_disabled
    r1 := warn_kms_key_rotation with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_kms_key_rotation with input as i with data.config.warn_mode as ["kms_key_rotation"]
    count(r2) == 1
    r3 := deny_kms_key_rotation with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_kms_key_rotation with input as i with data.config.warn_mode as ["kms_key_rotation"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}