package main

allowed_kms_key = [null]

lambdas[r] {
  r := input.resource_changes[_]
  r.type == "aws_lambda_function"
}

# Return true for lambda type terraform resource if it has environment variables in it
lambda_resources[r] {
  r := input.resource_changes[_]
  r.type == "aws_lambda_function"
  r.change.after.environment != []
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# === Rule to deny lambda without a vpc attached ===
lambda_without_vpc[msg] {
  r := lambdas[_]
  vpc_conf := r.change.after.vpc_config
  vpc_conf == []
  msg := sprintf(
    "%s: Lambda must reside within a VPC. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
    [r.address]
  )
}

deny_lambda_without_vpc[msg]{
  not array_contains(warning_mode, "lambda_without_vpc")
  lambda_without_vpc[_] != []
  msg := lambda_without_vpc[_]
}

warn_lambda_without_vpc[msg]{
  array_contains(warning_mode, "lambda_without_vpc")
  lambda_without_vpc[_] != []
  msg := lambda_without_vpc[_]
}