package main


# Test for valid multi_az RDS
test_rds_multi_az_invalid {
    i := data.mock.demo_non_compliant_rds
    r1 := warn_rds_multi_az with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_multi_az with input as i with data.config.warn_mode as ["rds_multi_az"]
    count(r2) == 1
    r3 := deny_rds_multi_az with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_multi_az with input as i with data.config.warn_mode as ["rds_multi_az"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_rds_multi_az_valid {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_multi_az with input as i with data.config.warn_mode as []
    r2 := warn_rds_multi_az with input as i with data.config.warn_mode as ["rds_multi_az"]
    r3 := deny_rds_multi_az with input as i with data.config.warn_mode as []
    r4 := deny_rds_multi_az with input as i with data.config.warn_mode as ["rds_multi_az"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for audit logging enabled
test_rds_audit_logging_disabled_invalid {
    i := data.mock.demo_non_compliant_rds
    r1 := warn_rds_audit_logging_disabled with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_audit_logging_disabled with input as i with data.config.warn_mode as ["rds_audit_logging_disabled"]
    count(r2) == 1
    r3 := deny_rds_audit_logging_disabled with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_audit_logging_disabled with input as i with data.config.warn_mode as ["rds_audit_logging_disabled"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_rds_audit_logging_disabled_valid {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_audit_logging_disabled with input as i with data.config.warn_mode as []
    r2 := warn_rds_audit_logging_disabled with input as i with data.config.warn_mode as ["rds_audit_logging_disabled"]
    r3 := deny_rds_audit_logging_disabled with input as i with data.config.warn_mode as []
    r4 := deny_rds_audit_logging_disabled with input as i with data.config.warn_mode as ["rds_audit_logging_disabled"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test RDS with default kms
#test_rds_with_default_kms_invalid {
#    i := data.mock.valid_rds_with_default_kms
#    r1 := warn_rds_with_default_kms with input as i with data.config.warn_mode as []
#    count(r1) == 0
#    r2 := warn_rds_with_default_kms with input as i with data.config.warn_mode as ["rds_with_default_kms"]
#    count(r2) == 1
#    r3 := deny_rds_with_default_kms with input as i with data.config.warn_mode as []
#    count(r3) == 1
#    r4 := deny_rds_with_default_kms with input as i with data.config.warn_mode as ["rds_with_default_kms"]
#    count(r4) == 0
#    count(r1) + count(r2) == 1 # Warning mode is off
#    count(r3) + count(r4) == 1 # Warning mode is on
#}

## Test RDS without KMS
#test_rds_without_kms_invalid {
#    i := data.mock.invalid_rds_with_encryption_false
#    r1 := warn_rds_without_kms with input as i with data.config.warn_mode as []
#    count(r1) == 0
#    r2 := warn_rds_without_kms with input as i with data.config.warn_mode as ["rds_without_kms"]
#    count(r2) == 1
#    r3 := deny_rds_without_kms with input as i with data.config.warn_mode as []
#    count(r3) == 1
#    r4 := deny_rds_without_kms with input as i with data.config.warn_mode as ["rds_without_kms"]
#    count(r4) == 0
#    count(r1) + count(r2) == 1 # Warning mode is off
#    count(r3) + count(r4) == 1 # Warning mode is on
#}
#
## Test RDS without KMS (null)
#test_rds_without_kms_null_invalid {
#    i := data.mock.invalid_rds_with_encryption_null
#    r1 := warn_rds_without_kms_null with input as i with data.config.warn_mode as []
#    count(r1) == 0
#    r2 := warn_rds_without_kms_null with input as i with data.config.warn_mode as ["rds_without_kms_null"]
#    count(r2) == 1
#    r3 := deny_rds_without_kms_null with input as i with data.config.warn_mode as []
#    count(r3) == 1
#    r4 := deny_rds_without_kms_null with input as i with data.config.warn_mode as ["rds_without_kms_null"]
#    count(r4) == 0
#    count(r1) + count(r2) == 1 # Warning mode is off
#    count(r3) + count(r4) == 1 # Warning mode is on
#}

#test_rds_without_encryption {
#    i := data.mock.invalid_rds_with_encryption_false
#    encryption_status = deny_rds_without_kms with input as i
#
#    count(encryption_status) == 1
#}
#
#test_rds_without_null_encryption {
#    i := data.mock.invalid_rds_with_encryption_null
#    encryption_status = deny_rds_without_kms_null with input as i
#
#    count(encryption_status) == 1
#}
#

## Test RDS replica without KMS
#test_rds_replica_without_kms_invalid {
#    i := data.mock.invalid_replica_without_kms
#    r1 := warn_rds_replica_without_kms with input as i with data.config.warn_mode as []
#    count(r1) == 0
#    r2 := warn_rds_replica_without_kms with input as i with data.config.warn_mode as ["rds_replica_without_kms"]
#    count(r2) == 1
#    r3 := deny_rds_replica_without_kms with input as i with data.config.warn_mode as []
#    count(r3) == 1
#    r4 := deny_rds_replica_without_kms with input as i with data.config.warn_mode as ["rds_replica_without_kms"]
#    count(r4) == 0
#    count(r1) + count(r2) == 1 # Warning mode is off
#    count(r3) + count(r4) == 1 # Warning mode is on
#}
#
#test_rds_replica_without_kms_valid {
#    i := data.mock.valid_replica_with_kms
#    r1 := warn_rds_replica_without_kms with input as i with data.config.warn_mode as []
#    r2 := warn_rds_replica_without_kms with input as i with data.config.warn_mode as ["rds_replica_without_kms"]
#    r3 := deny_rds_replica_without_kms with input as i with data.config.warn_mode as []
#    r4 := deny_rds_replica_without_kms with input as i with data.config.warn_mode as ["rds_replica_without_kms"]
#    count(r1) + count(r2) + count(r3) + count(r4) == 0
#}

test_rds_bkp_invalid {
    i := data.mock.demo_non_compliant_rds
    r1 := warn_rds_bkp with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_bkp with input as i with data.config.warn_mode as ["rds_bkp"]
    count(r2) == 1
    r3 := deny_rds_bkp with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_bkp with input as i with data.config.warn_mode as ["rds_bkp"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_rds_bkp_valid {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_bkp with input as i with data.config.warn_mode as []
    r2 := warn_rds_bkp with input as i with data.config.warn_mode as ["rds_bkp"]
    r3 := deny_rds_bkp with input as i with data.config.warn_mode as []
    r4 := deny_rds_bkp with input as i with data.config.warn_mode as ["rds_bkp"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for RDS Backup set
test_rds_bkp_period_invalid {
    i := data.mock.demo_invalid_rds_retention
    r1 := warn_rds_bkp_period with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_bkp_period with input as i with data.config.warn_mode as ["rds_bkp_period"]
    count(r2) == 1
    r3 := deny_rds_bkp_period with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_bkp_period with input as i with data.config.warn_mode as ["rds_bkp_period"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_rds_bkp_period_valid {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_bkp_period with input as i with data.config.warn_mode as []
    r2 := warn_rds_bkp_period with input as i with data.config.warn_mode as ["rds_bkp_period"]
    r3 := deny_rds_bkp_period with input as i with data.config.warn_mode as []
    r4 := deny_rds_bkp_period with input as i with data.config.warn_mode as ["rds_bkp_period"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for Deletion protection
test_rds_del_protection_enabled {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_del_protection with input as i with data.config.warn_mode as []
    r2 := warn_rds_del_protection with input as i with data.config.warn_mode as ["rds_del_protection"]
    r3 := deny_rds_del_protection with input as i with data.config.warn_mode as []
    r4 := deny_rds_del_protection with input as i with data.config.warn_mode as ["rds_del_protection"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

test_rds_del_protection_disabled {
    i := data.mock.demo_non_compliant_rds
    r1 := warn_rds_del_protection with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_del_protection with input as i with data.config.warn_mode as ["rds_del_protection"]
    count(r2) == 1
    r3 := deny_rds_del_protection with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_del_protection with input as i with data.config.warn_mode as ["rds_del_protection"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test for RDS is Publicly Accessible
test_rds_is_not_publicly_accessible {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_publicly_accessible with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_publicly_accessible with input as i with data.config.warn_mode as ["rds_publicly_accessible"]
    count(r2) == 0
    r3 := deny_rds_publicly_accessible with input as i with data.config.warn_mode as []
    count(r3) == 0
    r4 := deny_rds_publicly_accessible with input as i with data.config.warn_mode as ["rds_publicly_accessible"]
    count(r4) == 0
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

test_rds_is_publicly_accessible {
    i := data.mock.demo_non_compliant_rds
    r1 := warn_rds_publicly_accessible with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_publicly_accessible with input as i with data.config.warn_mode as ["rds_publicly_accessible"]
    count(r2) == 1
    r3 := deny_rds_publicly_accessible with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_publicly_accessible with input as i with data.config.warn_mode as ["rds_publicly_accessible"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test an invalid RDS instance without encryption enabled
test_rds_not_encrypted {
    i := data.mock.invalid_rds_without_encryption
    r1 := warn_rds_not_encrypted with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_not_encrypted with input as i with data.config.warn_mode as ["rds_not_encrypted"]
    count(r2) == 1
    r3 := deny_rds_not_encrypted with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_not_encrypted with input as i with data.config.warn_mode as ["rds_not_encrypted"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

# Test an valid RDS instance with encryption enabled
test_rds_del_protection_enabled {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_del_protection with input as i with data.config.warn_mode as []
    r2 := warn_rds_del_protection with input as i with data.config.warn_mode as ["rds_del_protection"]
    r3 := deny_rds_del_protection with input as i with data.config.warn_mode as []
    r4 := deny_rds_del_protection with input as i with data.config.warn_mode as ["rds_del_protection"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

# Test for auto upgrade enabled
test_rds_auto_upgrade_enabled {
    i := data.mock.demo_compliant_rds
    r1 := warn_rds_auto_upgrade with input as i with data.config.warn_mode as []
    r2 := warn_rds_auto_upgrade with input as i with data.config.warn_mode as ["rds_auto_upgrade"]
    r3 := deny_rds_auto_upgrade with input as i with data.config.warn_mode as []
    r4 := deny_rds_auto_upgrade with input as i with data.config.warn_mode as ["rds_auto_upgrade"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

test_rds_auto_upgrade_disabled {
    i := data.mock.demo_non_compliant_rds
    r1 := warn_rds_auto_upgrade with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_rds_auto_upgrade with input as i with data.config.warn_mode as ["rds_auto_upgrade"]
    count(r2) == 1
    r3 := deny_rds_auto_upgrade with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_rds_auto_upgrade with input as i with data.config.warn_mode as ["rds_auto_upgrade"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}
