package main

invalid_cidrs = ["0.0.0.0/0"]

security_group[r] {
    r := input.resource_changes[_]
}

################################################################################
## Test Cases                                                                 ##
################################################################################

# === Checks security groups embdedded ingress rules ===
sg_ingress[reason] {
  r := security_group[_]
  r.type == "aws_security_group"
  in := r.change.after.ingress[_]
  array_contains(in.cidr_blocks, invalid_cidrs[i])
  reason := sprintf(
    "%s security group ingress inline policy not allowed %q CIDR. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
    [r.address, invalid_cidrs[i]]
  )
}

deny_sg_ingress[msg]{
  not array_contains(warning_mode, "sg_ingress")
  sg_ingress[_] != []
  msg := sg_ingress[_]
}

warn_sg_ingress[msg]{
  array_contains(warning_mode, "sg_ingress")
  sg_ingress[_] != []
  msg := sg_ingress[_]
}

# === Checks security groups rule ingress rules ===
sgr_ingress[reason] {
  r := security_group[_]
  r.type == "aws_security_group_rule"
  r.change.after.type == "ingress"
  array_contains(r.change.after.cidr_blocks, invalid_cidrs[i])
  reason := sprintf(
    "%s security group ingress rule not allowed %q CIDR. See https://gitlab.bit9.local/production-infrastructure/cloud-governance/policy-packs/-/blob/master/policies/terraform/README.md for more details.",
    [r.address, invalid_cidrs[i]]
  )
}

deny_sgr_ingress[msg]{
  not array_contains(warning_mode, "sgr_ingress")
  sgr_ingress[_] != []
  msg := sgr_ingress[_]
}

warn_sgr_ingress[msg]{
  array_contains(warning_mode, "sgr_ingress")
  sgr_ingress[_] != []
  msg := sgr_ingress[_]
}
