package main

## unit test for security group to not allow cidr 0.0.0.0/0

### test if the cidr is valid in inline security group policy
test_sg_ingress_invalid {
    i := data.mock.invalid_sg_input
    r1 := warn_sg_ingress with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_sg_ingress with input as i with data.config.warn_mode as ["sg_ingress"]
    count(r2) == 1
    r3 := deny_sg_ingress with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_sg_ingress with input as i with data.config.warn_mode as ["sg_ingress"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_sg_ingress_valid {
    i := data.mock.valid_sg_input
    r1 := warn_sg_ingress with input as i with data.config.warn_mode as []
    r2 := warn_sg_ingress with input as i with data.config.warn_mode as ["sg_ingress"]
    r3 := deny_sg_ingress with input as i with data.config.warn_mode as []
    r4 := deny_sg_ingress with input as i with data.config.warn_mode as ["sg_ingress"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}

#### test if the cidr is valid in security group rule
test_sgr_ingress_invalid {
    i := data.mock.invalid_sgr_input
    r1 := warn_sgr_ingress with input as i with data.config.warn_mode as []
    count(r1) == 0
    r2 := warn_sgr_ingress with input as i with data.config.warn_mode as ["sgr_ingress"]
    count(r2) == 1
    r3 := deny_sgr_ingress with input as i with data.config.warn_mode as []
    count(r3) == 1
    r4 := deny_sgr_ingress with input as i with data.config.warn_mode as ["sgr_ingress"]
    count(r4) == 0
    count(r1) + count(r2) == 1 # Warning mode is off
    count(r3) + count(r4) == 1 # Warning mode is on
}

test_sgr_ingress_valid {
    i := data.mock.valid_sgr_input
    r1 := warn_sgr_ingress with input as i with data.config.warn_mode as []
    r2 := warn_sgr_ingress with input as i with data.config.warn_mode as ["sgr_ingress"]
    r3 := deny_sgr_ingress with input as i with data.config.warn_mode as []
    r4 := deny_sgr_ingress with input as i with data.config.warn_mode as ["sgr_ingress"]
    count(r1) + count(r2) + count(r3) + count(r4) == 0
}